<?php
$privatefile = "data/privatekey.pem";
$publicfile = "data/publickey.pem";
$cleartextfile = "data/cleartext";

if($_POST["action"] == "genkey") {  
    // Create the keypair
    $config = array(
        "digest_alg" => "sha512",
        "private_key_bits" => 1024,
        "private_key_type" => OPENSSL_KEYTYPE_RSA,
    );  
    $config_priv = [];
    /* Uncomment these codes for Windows if configuration error
        $openssl_conf = "c:/xampp/php/extras/openssl/openssl.cnf";
        $config["config"] = $openssl_conf;
        $config_priv["config"] = $openssl_conf;
    */
    $res=openssl_pkey_new($config);
    if(!$res) { echo "\nopenssl_pkey_new: " . openssl_error_string(); }

    // Get private key
    openssl_pkey_export($res, $privatekey, "", $config_priv); 
    if(!$privatekey) { echo "\nopenssl_pkey_export: " . openssl_error_string(); }    
    file_put_contents($privatefile, $privatekey);

    // Get public key
    $pkeydetails=openssl_pkey_get_details($res);
    if(!$pkeydetails) { echo "\nopenssl_pkey_get_details: " . openssl_error_string(); } 
    $publickey=$pkeydetails["key"];
    file_put_contents($publicfile, $publickey);
    
    /* response */
    echo $publickey;
}

if($_POST["action"] == "put") {
    $endata = $_POST["endata"];
    $privatekey = file_get_contents($privatefile);
    openssl_private_decrypt(base64_decode($endata), $cleartext, $privatekey);
    if(!$cleartext) { echo "\noopenssl_private_decrypt: " . openssl_error_string(); } 
    file_put_contents($cleartextfile, $cleartext);
}
?>